/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * IAMU CMS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as url from "url";
import * as portableFetch from "portable-fetch";
import { Configuration } from "./configuration";

const BASE_PATH = "http://localhost".replace(/\/+$/, "");

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};

/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}

/**
 *  
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}

/**
 * 
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
    protected configuration: Configuration | undefined;

    constructor(configuration?: Configuration, protected basePath: string = BASE_PATH, protected fetch: FetchAPI = portableFetch) {
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
};

/**
 * 
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
    name: "RequiredError" = "RequiredError";
    constructor(public field: string, msg?: string) {
        super(msg);
    }
}

/**
 * 
 * @export
 * @interface AssociatedMedia
 */
export interface AssociatedMedia {
    /**
     * 
     * @type {Media}
     * @memberof AssociatedMedia
     */
    media: Media;
    /**
     * Media contents in different languages
     * @type {Array<Item>}
     * @memberof AssociatedMedia
     */
    items: Array<Item>;
}

/**
 * 
 * @export
 * @interface Config
 */
export interface Config {
    /**
     * 
     * @type {Exhibit}
     * @memberof Config
     */
    exhibit: Exhibit;
    /**
     * Media files & texts associated with the exhibit
     * @type {Array<AssociatedMedia>}
     * @memberof Config
     */
    associatedMedia: Array<AssociatedMedia>;
}

/**
 * Config for the exhibit itself
 * @export
 * @interface Exhibit
 */
export interface Exhibit {
    /**
     * The name of the exhibit
     * @type {string}
     * @memberof Exhibit
     */
    name: string;
    /**
     * Arbitrary metadata
     * @type {any}
     * @memberof Exhibit
     */
    meta: any;
}

/**
 * Metadata of a single media item
 * @export
 * @interface Item
 */
export interface Item {
    /**
     * The date & time when the media was created
     * @type {Date}
     * @memberof Item
     */
    created_at: Date;
    /**
     * The language of the content of this media item
     * @type {string}
     * @memberof Item
     */
    language: string;
    /**
     * If this is a media item, the URL to the audio / image / video file
     * @type {string}
     * @memberof Item
     */
    path?: string;
    /**
     * If this is a text item, the text itself
     * @type {string}
     * @memberof Item
     */
    text?: string;
}

/**
 * Description of media content itself
 * @export
 * @interface Media
 */
export interface Media {
    /**
     * The media type
     * @type {string}
     * @memberof Media
     */
    type: Media.TypeEnum;
    /**
     * The user ID of the user who created the media
     * @type {string}
     * @memberof Media
     */
    created_by: string;
    /**
     * The date & time when the media was created
     * @type {Date}
     * @memberof Media
     */
    created_at: Date;
    /**
     * The media's name
     * @type {string}
     * @memberof Media
     */
    name: string;
}

/**
 * @export
 * @namespace Media
 */
export namespace Media {
    /**
     * @export
     * @enum {string}
     */
    export enum TypeEnum {
        Text = 'text',
        Audio = 'audio',
        Image = 'image',
        Video = 'video'
    }
}

/**
 * 
 * @export
 * @interface ModelError
 */
export interface ModelError {
    /**
     * A textual description of the error
     * @type {string}
     * @memberof ModelError
     */
    msg?: string;
}


/**
 * CmsApi - fetch parameter creator
 * @export
 */
export const CmsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet(exhibitId: string, options: any = {}): FetchArgs {
            // verify required parameter 'exhibitId' is not null or undefined
            if (exhibitId === null || exhibitId === undefined) {
                throw new RequiredError('exhibitId','Required parameter exhibitId was null or undefined when calling exhibitConfigGet.');
            }
            const localVarPath = `/exhibitConfig`;
            const localVarUrlObj = url.parse(localVarPath, true);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (exhibitId !== undefined) {
                localVarQueryParameter['exhibitId'] = exhibitId;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CmsApi - functional programming interface
 * @export
 */
export const CmsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet(exhibitId: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Config> {
            const localVarFetchArgs = CmsApiFetchParamCreator(configuration).exhibitConfigGet(exhibitId, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * CmsApi - factory interface
 * @export
 */
export const CmsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet(exhibitId: string, options?: any) {
            return CmsApiFp(configuration).exhibitConfigGet(exhibitId, options)(fetch, basePath);
        },
    };
};

/**
 * CmsApi - object-oriented interface
 * @export
 * @class CmsApi
 * @extends {BaseAPI}
 */
export class CmsApi extends BaseAPI {
    /**
     * 
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CmsApi
     */
    public exhibitConfigGet(exhibitId: string, options?: any) {
        return CmsApiFp(this.configuration).exhibitConfigGet(exhibitId, options)(this.fetch, this.basePath);
    }

}

