/**
 * IAMU CMS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/// <reference path="../custom.d.ts" />
import { Configuration } from "./configuration";
/**
 *
 * @export
 */
export declare const COLLECTION_FORMATS: {
    csv: string;
    ssv: string;
    tsv: string;
    pipes: string;
};
/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}
/**
 *
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}
/**
 *
 * @export
 * @class BaseAPI
 */
export declare class BaseAPI {
    protected basePath: string;
    protected fetch: FetchAPI;
    protected configuration: Configuration | undefined;
    constructor(configuration?: Configuration, basePath?: string, fetch?: FetchAPI);
}
/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export declare class RequiredError extends Error {
    field: string;
    name: "RequiredError";
    constructor(field: string, msg?: string);
}
/**
 *
 * @export
 * @interface AssociatedMedia
 */
export interface AssociatedMedia {
    /**
     *
     * @type {Media}
     * @memberof AssociatedMedia
     */
    media: Media;
    /**
     * Media contents in different languages
     * @type {Array<Item>}
     * @memberof AssociatedMedia
     */
    items: Array<Item>;
}
/**
 *
 * @export
 * @interface Config
 */
export interface Config {
    /**
     *
     * @type {Exhibit}
     * @memberof Config
     */
    exhibit: Exhibit;
    /**
     * Media files & texts associated with the exhibit
     * @type {Array<AssociatedMedia>}
     * @memberof Config
     */
    associatedMedia: Array<AssociatedMedia>;
}
/**
 * Config for the exhibit itself
 * @export
 * @interface Exhibit
 */
export interface Exhibit {
    /**
     * The name of the exhibit
     * @type {string}
     * @memberof Exhibit
     */
    name: string;
    /**
     * Arbitrary metadata
     * @type {any}
     * @memberof Exhibit
     */
    meta: any;
}
/**
 * Metadata of a single media item
 * @export
 * @interface Item
 */
export interface Item {
    /**
     * The date & time when the media was created
     * @type {Date}
     * @memberof Item
     */
    created_at: Date;
    /**
     * The language of the content of this media item
     * @type {string}
     * @memberof Item
     */
    language: string;
    /**
     * If this is a media item, the URL to the audio / image / video file
     * @type {string}
     * @memberof Item
     */
    path?: string;
    /**
     * If this is a text item, the text itself
     * @type {string}
     * @memberof Item
     */
    text?: string;
}
/**
 * Description of media content itself
 * @export
 * @interface Media
 */
export interface Media {
    /**
     * The media type
     * @type {string}
     * @memberof Media
     */
    type: Media.TypeEnum;
    /**
     * The user ID of the user who created the media
     * @type {string}
     * @memberof Media
     */
    created_by: string;
    /**
     * The date & time when the media was created
     * @type {Date}
     * @memberof Media
     */
    created_at: Date;
    /**
     * The media's name
     * @type {string}
     * @memberof Media
     */
    name: string;
}
/**
 * @export
 * @namespace Media
 */
export declare namespace Media {
    /**
     * @export
     * @enum {string}
     */
    enum TypeEnum {
        Text = "text",
        Audio = "audio",
        Image = "image",
        Video = "video"
    }
}
/**
 *
 * @export
 * @interface ModelError
 */
export interface ModelError {
    /**
     * A textual description of the error
     * @type {string}
     * @memberof ModelError
     */
    msg?: string;
}
/**
 * CmsApi - fetch parameter creator
 * @export
 */
export declare const CmsApiFetchParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    exhibitConfigGet(exhibitId: string, options?: any): FetchArgs;
};
/**
 * CmsApi - functional programming interface
 * @export
 */
export declare const CmsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    exhibitConfigGet(exhibitId: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Config>;
};
/**
 * CmsApi - factory interface
 * @export
 */
export declare const CmsApiFactory: (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) => {
    /**
     *
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    exhibitConfigGet(exhibitId: string, options?: any): Promise<Config>;
};
/**
 * CmsApi - object-oriented interface
 * @export
 * @class CmsApi
 * @extends {BaseAPI}
 */
export declare class CmsApi extends BaseAPI {
    /**
     *
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CmsApi
     */
    exhibitConfigGet(exhibitId: string, options?: any): Promise<Config>;
}
